01.09.2021 - 1.5.02
- Made "close" button visible in KDE
- Added some compile-time checks to make project build on Arch

---------------------------------------------------------------------------

06.04.2019 - 1.5.01
- Qt5 port

---------------------------------------------------------------------------

29.07.2016 - 1.3.04
- made code compile with GCC 6
- retries on file read failure
- fix for UTF8 output in calls to mp3gain (Linux only)
- new transformation: "Remove Xing or LAME streams from CBR files"
- always show sessions button if there are more than 1 sessions

---------------------------------------------------------------------------

08.03.2015 - 1.3.03
- improved error reporting
- speed improvements for external drives (USB, network, ...)
- different treatment for the Xing frame being included in the frame count

---------------------------------------------------------------------------

17.07.2014 - 1.3.01
- fixed crash caused by saving very small images
- build fix
- disabled Discogs integration

---------------------------------------------------------------------------

16.01.2014 - 1.3.00
- build fix for clang and for Solaris
- added offset to the output created via the command line
- fixed incorrect message occurring some times when start after a crash
- better logging and retries for write errors
- fixed broken links in documentation and moved alternate downloads
    from Dropbox to my ISP
- new version number to support the new "unstable" branch

---------------------------------------------------------------------------

31.03.2013 - 1.2.00
- new version number to support the new "stable" branch

---------------------------------------------------------------------------

01.12.2012 - 1.1.21.080
- fixed bug that caused a "%s" to be shown instead of the list of files
    about to be changed

---------------------------------------------------------------------------

20.10.2012 - 1.1.20.077
- Discogs fix

---------------------------------------------------------------------------

29.04.2012 - 1.1.19.075
- French translation

---------------------------------------------------------------------------

06.04.2012 - 1.1.18.074
- German translation
- made code compilable on GCC 4.7
- several translation fixes

---------------------------------------------------------------------------

17.03.2012 - 1.1.17.073
- fixed crash introduced in 1.1.16 with translation changes

---------------------------------------------------------------------------

11.03.2012 - 1.1.16.072
- made program translatable
- added Czech translation

---------------------------------------------------------------------------

01.02.2012 - 1.1.12.068
- external tools
- possibility of applying transformation lists in CLI mode
- "Open containing folder" in the main window
- delete files from the main window
- close buttons for Gnome 3
- APE remover
- non-audio remover
- CLI analyzer uses session settings to determine quality thresholds
- fixed menu tooltips that disappeared too quickly

---------------------------------------------------------------------------

03.12.2011 - 1.1.09.064
- moved to Discogs API V2
- added codepage support when copying ID3V1 to ID3V2
- fixed crash caused by ID3V2.4 tag with invalid flags
- fixed splitting of unsupported ID3V2 tags
- fixed Xing generation for small bitrates

---------------------------------------------------------------------------

28.08.2011 - 1.1.08.062
- made Discogs queries work again, after a Discogs API change
- fixed track numbering when querying multi-volume albums from Discogs
- made Linux shell integration accept file names containing spaces
- added close button for dialogs on Gnome 3

---------------------------------------------------------------------------

30.07.2011 - 1.1.07.061
- shell integration for Linux
- replaced MP3Diags with MP3Diags-unstable in places where this wasn't done
- restructured the .spec file
- added close button on Gnome 3

---------------------------------------------------------------------------

22.07.2011 - 1.1.06.059
- shell integration fixes

---------------------------------------------------------------------------

21.07.2011 - 1.1.05.058
- shell integration (Windows only)

---------------------------------------------------------------------------

17.07.2011 - 1.1.04.057
- folder-based sessions based on command-line parameters

---------------------------------------------------------------------------

16.06.2011 - 1.1.03.056
- integrated command-line mode by Michael Elsdörfer

---------------------------------------------------------------------------

30.05.2011 - 1.1.01.054
- created unstable branch

---------------------------------------------------------------------------

28.05.2011 - 1.0.08.053
- fixed crash when trying to save after error at startup
- added branch support to build process

---------------------------------------------------------------------------

29.12.2010 - 1.0.07.052
- fixed crash in folder filter dialog
- made project compilable on Fedora 13 and 14

---------------------------------------------------------------------------

04.07.2010 - 1.0.06.051
- fixed crash caused by invalid Lyrics tag
- fixed assertion failure when opening the folder filter in Windows

---------------------------------------------------------------------------

17.03.2010 - 1.0.05.050
- fixed issue #23 (assertion failure)

---------------------------------------------------------------------------

07.03.2010 - 1.0.04.049
- fixed crash triggered by invalid frame lengths in ID3V2
- fixed crash that occured when the backup directory couldn't be created

---------------------------------------------------------------------------

29.01.2010 - 1.0.03.048
- fixed crash triggered by GEOB frames containing UTF-16 text

---------------------------------------------------------------------------

12.01.2010 - 1.0.02.047
- fixed crash triggered by trying to repair broken ID3V2 tags that contain
    images
- fixed crash that occurred when changing file names manually in the file
    renamer, without defining a pattern
- fixed crash caused by unsynchronized ID3V2.4.0 frames that end with 0xff

---------------------------------------------------------------------------

11.12.2009 - 1.0.01.046
- fixed crash that occurred when running on Qt 4.6
- fixed crash that occurred when changing song info in the tag editor if
    songs had images stored as BMP or anything else besides JPG or PNG

---------------------------------------------------------------------------

29.11.2009 - 1.0.00.045
- wording changes to reflect non-beta status
- pressing CTRL+C when viewing full-size images in the tag editor or in
    "Tag details" in the main window copies the image to the clipboard
- added "Rating" and changed field order in "Tag details" to match the Tag
    editor

---------------------------------------------------------------------------

04.11.2009 - 0.99.06.044

- fixed a crash in folder filter
- fixed bug causing non-normalized files having any TXXX frame to appear
    normalized
- case is ignored for file extension, so .Mp3 or .mP3 files are recognized
- better support and more consistent handling for TXXX and text frames in
    ID3V2
- reduced number of locales by eliminating redundant ones
- disabled CTRL+A selection in the main window
- static link for serialization
- added trace details for web downloads

---------------------------------------------------------------------------

27.10.2009 - 0.99.06.043

- "Simple view" in file configuration
- fixed crash on empty text frames in ID3V2
- generic binaries for Linux
- BuildMp3Diags.hta detects VS version
- documentation updates

---------------------------------------------------------------------------

20.10.2009 - 0.99.06.042

- better support for binary frames in ID2V2.4.0
- fixed bug resulting in crash when files were modified in external tools
- fixed bug resulting in crash when renaming files if a filter is applied
- fixed bug resulting in crash when going to "Tag details" for files using
    Unicode in USLT (issue 40)
- added option to include styles in Discogs info
- added case-change option to the tag editor
- better detection and notification for changed files before applying
    transformations or saving from the tag editor
- file renamer allows file names to be changed manually
- file renamer can use "duplicate" label for unrated songs
- images shown for Lyrics tags
- improved case-change transformation
- removing images from the tag editor now works even for non-cover images

---------------------------------------------------------------------------

09.10.2009 - 0.99.06.041

- brought documentation up to date
- added test for ReplayGain info stored inside Id3V2
- failing to read text frames from files no longer causes crashes
- fixed bug resulting in crash when 2 ID3V2 tags are present and
    "Discard invalid ID3V2 data" gets called
- XML export now works when names contain double quotes
- locale in export dialog
- locale lists are now sorted
- long text frames are now truncated when shown in the "File info" area
- changed names and order for tabs under Config/Files
- made transformation options work correctly in MSVC

---------------------------------------------------------------------------

30.09.2009 - 0.99.06.040

- "Various Artists" support
- all pictures are shown and can be viewed in full size in "Tag details"
- all pictures from a file are shown in the tag editor
- patterns in the tag editor may now be disabled
- export as M3U or XML
- better handling of text frames containing null characters
- auto-size for the tag editor's "current file" area
- better column widths in the tag editor
- improved HTA for Windows build

---------------------------------------------------------------------------

23.09.2009 - 0.99.05.038
- fixed bug introduced in 0.99.05.037 causing crashes when finding empty
    ID3V2 frames
- new build process for Windows
- 4th custom transf list now defaults to a "fix-all" approach

---------------------------------------------------------------------------

17.09.2009 - 0.99.05.037
- fixes on right-click
- UTF-8 strings recognized in ID3V2.3.0
- fixed bug 35 (assertion failure)
- faster tracer
- code compilable with VS 2008 (port by Sebastian Schuberth)

---------------------------------------------------------------------------

07.09.2009 - 0.99.05.034
- drive labels shown in Windows
- mp3gain can be started now if it's in a directory containing spaces
- configurable invalid characters and replacement for file renamer
- automatic check for new versions
- text inside square, curly, and angle brackets removed from web queries
- improved tracing code
- no longer rescan the files if exiting tag editor without changes
- replace non-alphanumeric chars with spaces in web queries (issue 2)
- better sorting in the tag editor for albums with unusual track numbers
- a default .ini name is generated in most cases
- (probably) fixed an assert (not sure because couldn't reproduce it)
- tracks without a track number are put at the end in the tag editor
- let the user know about reporting support notes and about patterns
- better detection of exceptions in threads
- exceptions that propagate from slots are now caught
- default "actions to be taken" no longer shown when applying transforms
- file info for StreamWriter

---------------------------------------------------------------------------

02.09.2009 - 0.99.05.033
- fixed crash in Windows when checking a whole drive
- fixed crash when saving data from the tag editor
- improved trace speed on Windows
- fixed potential crash at startup
- fixed crash when changing a file that is being used by other program
- more details and better formatting in assert messages and trace files
- MPEG2 Layer3 streams no longer show Support note
- improved temporary file generation, which can result in faster transforms
- F1 help now works for the first session dialog
- smaller TABs in the "Tag details" area make "Other info" more readable
- better HTML paragraph formatting

---------------------------------------------------------------------------

23.08.2009 - 0.99.05.032
- new Qt (4.5.2) and MinGW (3.4.5) for the Windows version
- restructured crash detector
- fixed Windows issue with rectangles being shown instead of letters
- Lyrics partial support
- warning that may corrupt data
- note about how to change selected files
- HTML clean up

---------------------------------------------------------------------------

18.08.2009 - 0.99.05.031
- crash detection
- fixed small memory leak in config dialog
- fixed small memory leak in the tag editor
- content is shown for GEOB frames
- .ID3 files are now loaded in addition to .MP3
- made the counter shown when applying transforms increment on new file
    (until now it was incremented for each transform)
- "Various artists" no longer set as "artist" when downloading track
    info from MusicBrainz
- fixed "current cell" in the tag editor (until now, when dragging the
    mouse to select several cells, the current cell was wrong, leading to
    setting values incorrectly
- fixed a bug that didn't allow removal of the track number
- slightly improved the normalizer, so a "busy" cursor is shown when the
    connection to the underlying process is lost (the program seems frozen,
    but it resumes after about 30 seconds)

---------------------------------------------------------------------------

28.07.2009 - 0.99.05.030
- fixed a bug that caused the tag editor to reserve more space than needed
    even if the "fast save" option was turned off
- fixed a bug that prevented removal of elements from lists
- fixed a bug in the ID3V2 tag writer that prevented "Discard invalid ID3V2
    data" and other transformations to properly work with ID3V2.4.0 tags
    that contain UTF8-encoded strings, resulting in a broken ID3V2.3.0 tag
- file renamer now accepts patterns with no directory separators, in which
    case the renamed files are placed in the source directory
- pattern dialogs now show the current line and column
- fixed an assertion in the code that determines the file list
- added tooltips for all the notes in the main file table
- improved speed for "Discard invalid ID3V2 data" when no changes are done
- transformation name included in the dialog that shows which file is
    currently processed
- broken ID3V2 streams get removed when saving from the tag editor
- the tag editor no longer triggers an assertion failure if non-default
    settings in the file section of the configuration dialog; (e.g. until
    now saving from the tag editor while original files weren't deleted
    resulted in this assertion failure)
- fixed a bug in the "Change case for ID3V2 text frames" that resulted in
    a program crash if some fields were missing from the ID3V2 tag

---------------------------------------------------------------------------

26.07.2009 - 0.99.05.029
- improved paste in tag editor (it is possible to paste to multiple cells
    or to paste file names copied from file browsers)
- configurable max image size
- button to remove image files
- fixed loading images from current dir
- fixed a bug in tag editor patterns that prevented patterns ending with a
    static text from working
- Windows only: fixed pasting image file that was copied from Windows
    Explorer

---------------------------------------------------------------------------

23.07.2009 - 0.99.05.028
- fast save in the tag editor

---------------------------------------------------------------------------

21.07.2009 - 0.99.04.027
- file renamer can work with the list of visible files instead of the
    current album if the user holds CTRL down when pressing the button
- new transform for keeping a single image, as front cover
- new transform for removing ID3V1
- configurable visible transformations
- tooltips for the transformations menu
- use of backslash for path separator on Windows
- fixed some bugs in the directory filter
- made F1 work on Windows
- fixed normalization status on Windows
- directory filter no longer shows some directories that don't make sense
- more checks + fixed error reporting in file renamer
- "sessions" button visible by default for second and later sessions

---------------------------------------------------------------------------

17.07.2009 - 0.99.04.026
- size grip on most dialogs
- F1 help

---------------------------------------------------------------------------

15.07.2009 - 0.99.03.025
- restructured Unicode stream classes
- Lyrics inside ID3V2 are now shown

---------------------------------------------------------------------------

15.07.2009 - 0.99.03.024
- switched to fstream_utf8

---------------------------------------------------------------------------

13.07.2009 - 0.99.03.023
- tag editor now looks at filter
- files changed in the tag editor no longer show up in the main window if
    a filter is applied and they don't match the filter
- better alignment for text in note column header on Ubuntu
- replaced C / POSIX calls with Qt calls

---------------------------------------------------------------------------

09.07.2009 - 0.99.03.022
- configurable colors

---------------------------------------------------------------------------

09.07.2009 - 0.99.03.021
- 2-letter labels
- gradient grouping of notes
- more consistent font handling
- detecting files changed by external tools
- tooltips are shown for the column headers in the file table

---------------------------------------------------------------------------

05.07.2009 - 0.99.02.020
- added sysinfo to "about" dialog
- more details in sysinfo
- made file renamer work on Windows
- file renamer now replaces invalid characters in file names
- made logger work on Windows 7 (and probably Vista)

---------------------------------------------------------------------------

29.06.2009 - 0.99.02.019
- downloaded images are no longer lost when saving in the tag editor
- duration is now shown for audio streams
- fixed assertion caused by files with too many streams
- assertion instructs reports to be made on forum instead of email
- number of files that might get changed is shown before processing
    multiple files
- assert message includes more info about the OS
- multiple ID3 stream remover no longer included by default in second list
- some changes to .spec file in the hope it will work on Mandriva

---------------------------------------------------------------------------

24.06.2009 - 0.99.02.018
- made -mt suffix default for Boost Serialization

---------------------------------------------------------------------------

24.06.2009 - 0.99.02.017
- always use multithreaded libraries
- improved assert dialog; now it has more data, which can be copied and
    even emailed directly
- the tag editor shows a warning in some cases when a user action would
    result in discarded images

---------------------------------------------------------------------------

21.06.2009 - 0.99.02.016
- fixed an assertion failure that was triggered by an unsupported text
    encoding in APIC
- added support for UTF8 text encoding in APIC
- made the documentation look slightly better on IE6

---------------------------------------------------------------------------

20.06.2009 - 0.99.02.015
- made compilable on Fedora 11 and added Fedora 11 build
- copying missing ID3V1 fields to ID3V2 no longer part of the default
    custom transformation list 2

---------------------------------------------------------------------------

18.06.2009 - 0.99.02.014
- the tag editor loads albums much faster than before; this is most visible
    when navigating to the next / previous album

---------------------------------------------------------------------------

16.06.2009 - 0.99.02.013
- Windows-only: new Boost Serialization library, compiled with
    multithreading support
- Windows-only: new install script, so now the setup has a more modern look
    and allows the user to run the program when the install completes

---------------------------------------------------------------------------

14.06.2009 - 0.99.02.012
- added support for UTF8 in ID3V240
- added maximize button to most windows in Windows (but could not get this
    to work with Gnome)
- removed "What's this" button from most windows
- now the main window shows the session name if more than 1 session was
    defined
- now the main window shows up maximized in Gnome and Windows if it was
    maximized when it was closed
- changed documentation links to point to new site, at SourceForge
- minor documentation improvements

---------------------------------------------------------------------------

06.06.2009 - 0.99.02.011
- added dependency to guarantee that SVG icons can be displayed on non-KDE
    desktops
- fixed an assertion in "Sessions / Save as"
- doc comment changes to prepare for moving to SourceForge

---------------------------------------------------------------------------

04.06.2009 - 0.99.02.010
- fixed a bug that could result in removal of audio data when using the
    "Remove inner non-audio" transformation
- first Windows version
- fixed incorrect handling of the option to keep a single image in an
    ID3V2 tag

---------------------------------------------------------------------------

03.06.2009 - 0.99.01.009
- added scripts for Ubuntu builds
- made compilable on Windows
- added some Windows-specific icons, to replace those that are displayed
    incorrectly
- improved ColumnResizer
- switched text in SVGs to "path", to avoid issues related to missing fonts
- fixed Config / Files so it's no longer possible to only to uncheck all
    radio buttons
- better handling of light background colors in the Notes table
- fixed a bug that could result in erased files when the disk becomes full
- change header / footer layout in the documentation

---------------------------------------------------------------------------

25.05.2009 - 0.99.0.008
- increased cell width for notes, to look OK with more fonts
- added an #include so gcc 4.4 can compile the project
- now using black instead of "selection" color for notes if the contrast
    with the background is too low
- improved the workaround that is needed for multiline text, so now it can
    handle all fonts (previously a message used to show up telling the user
    to change the font)
- added horizontal scrollbar to directory trees
- install.sh now exits errors

---------------------------------------------------------------------------

22.05.2009 - 0.99.0.007
- first public version; most of the 1.0 features implemented and functional
    (what's left is an option to write ID3V2 tags "in place", to be used if
    the tag editor seems too slow; this may lead to data loss in cases of
    program / computer crash)
